#pragma once
#include "State.h"
#include "d3dx9.h"

class Agent;

class AgentState_Idle : public State<Agent>
{
	AgentState_Idle(){}
	AgentState_Idle(AgentState_Idle&){}
	void operator=(AgentState_Idle&){}
public:
	static AgentState_Idle* Instance();
	void Enter(Agent* owner);
	void Execute(Agent* owner, float dt);
	void Exit(Agent* owner);
	void Render(Agent* owner);
};

class AgentState_Move : public State<Agent>
{
	AgentState_Move(){}
	AgentState_Move(AgentState_Move&){}
	void operator=(AgentState_Move&){}

public:
	static AgentState_Move* Instance();
	void Enter(Agent* owner);
	void Execute(Agent* owner, float dt);
	void Exit(Agent* owner);
	void Render(Agent* owner);
};

class AgentState_Attack : public State<Agent>
{
	AgentState_Attack(){}
	AgentState_Attack(AgentState_Attack&){}
	void operator=(AgentState_Attack&){}
public:
	static AgentState_Attack* Instance();
	void Enter(Agent* owner);
	void Execute(Agent* owner, float dt);
	void Exit(Agent* owner);
	void Render(Agent* owner);
};

class AgentState_Retreat : public State<Agent>
{
	AgentState_Retreat(){}
	AgentState_Retreat(AgentState_Retreat&){}
	void operator=(AgentState_Retreat&){}
public:
	static AgentState_Retreat* Instance();
	void Enter(Agent* owner);
	void Execute(Agent* owner, float dt);
	void Exit(Agent* owner);
	void Render(Agent* owner);
};

class AgentState_GlobalRed : public State<Agent>
{
	IDirect3DTexture9*	m_Texture;
	AgentState_GlobalRed(){}
	AgentState_GlobalRed(AgentState_GlobalRed&){}
	void operator=(AgentState_GlobalRed&){}
public:
	static AgentState_GlobalRed* Instance();
	void Enter(Agent* owner);
	void Execute(Agent* owner, float dt);
	void Exit(Agent* owner);
	void Render(Agent* owner);
};

class AgentState_GlobalBlue : public State<Agent>
{
	IDirect3DTexture9*	m_Texture;
	AgentState_GlobalBlue(){}
	AgentState_GlobalBlue(AgentState_GlobalBlue&){}
	void operator=(AgentState_GlobalBlue&){}
public:
	static AgentState_GlobalBlue* Instance();
	void Enter(Agent* owner);
	void Execute(Agent* owner, float dt);
	void Exit(Agent* owner);
	void Render(Agent* owner);
};

