#pragma once
#include "State.h"

class AgentTeam;
class HealthPickup;
class AmmoPickup;
class Agent;

class AgentTeamState_Regroup : public State<AgentTeam>
{
	AgentTeamState_Regroup(){}
	AgentTeamState_Regroup(AgentTeamState_Regroup&){}
	void operator=(AgentTeamState_Regroup&){}
public:

	void Enter(AgentTeam* owner);
	void Execute(AgentTeam* owner, float dt);
	void Exit(AgentTeam* owner);
	void Render(AgentTeam* owner);
	static AgentTeamState_Regroup* Instance();
};

class AgentTeamState_Retreat : public State<AgentTeam>
{
	AgentTeamState_Retreat(){}
	AgentTeamState_Retreat(AgentTeamState_Retreat&){}
	void operator=(AgentTeamState_Retreat&){}
public:

	void Enter(AgentTeam* owner);
	void Execute(AgentTeam* owner, float dt);
	void Exit(AgentTeam* owner);
	void Render(AgentTeam* owner);
	static AgentTeamState_Retreat* Instance();
};


class AgentTeamState_Attack : public State<AgentTeam>
{
	AgentTeamState_Attack(){}
	AgentTeamState_Attack(AgentTeamState_Attack&){}
	void operator=(AgentTeamState_Attack&){}
public:
	void Enter(AgentTeam* owner);
	void Execute(AgentTeam* owner, float dt);
	void Exit(AgentTeam* owner);
	void Render(AgentTeam* owner);
	static AgentTeamState_Attack* Instance();
};

class AgentTeamState_LowHealth : public State<AgentTeam>
{
	AgentTeamState_LowHealth(){}
	AgentTeamState_LowHealth(AgentTeamState_LowHealth&){}
	void operator=(AgentTeamState_LowHealth&){}
	HealthPickup* m_SelectedPickup;
	Agent*	m_SelectedAgent;	
	int		m_HealthOnEnter;
public:
	void Enter(AgentTeam* owner);
	void Execute(AgentTeam* owner, float dt);
	void Exit(AgentTeam* owner);
	void Render(AgentTeam* owner);
	static AgentTeamState_LowHealth* Instance();
};

class AgentTeamState_LowAmmo : public State<AgentTeam>
{
	AgentTeamState_LowAmmo(){}
	AgentTeamState_LowAmmo(AgentTeamState_LowAmmo&){}
	void operator=(AgentTeamState_LowAmmo&){}
	AmmoPickup* m_SelectedPickup;
	Agent* m_SelectedAgent;
	int m_AmmoOnEnter;
public:
	void Enter(AgentTeam* owner);
	void Execute(AgentTeam* owner, float dt);
	void Exit(AgentTeam* owner);
	void Render(AgentTeam* owner);
	static AgentTeamState_LowAmmo* Instance();
};

class AgentTeamState_Global : public State<AgentTeam>
{
	AgentTeamState_Global(){}
	AgentTeamState_Global(AgentTeamState_Global&){}
	void operator=(AgentTeamState_Global&){}
public:

	void Enter(AgentTeam* owner);
	void Execute(AgentTeam* owner, float dt);
	void Exit(AgentTeam* owner);
	void Render(AgentTeam* owner);
	static AgentTeamState_Global* Instance();
};

/*
class AgentTeamState_Test : public State<AgentTeam>
{
	AgentTeamState_Test(){}
	AgentTeamState_Test(AgentTeamState_Test&){}
	void operator=(AgentTeamState_Test&){}
	int m_SelectedAgent;
public:

	void Enter(AgentTeam* owner);
	void Execute(AgentTeam* owner, float dt);
	void Exit(AgentTeam* owner);
	void Render(AgentTeam* owner);
	static AgentTeamState_Test* Instance();
};
*/
