#pragma once
#include "d3dx9.h"

#define FLOAT_EPSILON 0.0001f
#define VECTOR_EPSILON D3DXVECTOR3(0.0001f, 0.0001f, 0.0001f)
#define D3DXZEROVEC3 D3DXVECTOR3(0.0f,0.0f,0.0f)

//Transforms a 2D vector using D3DX functions.
inline D3DXVECTOR2 TransformVector(D3DXVECTOR2* vIn, D3DXMATRIX* mIn)
{
	D3DXVECTOR4 temp;
	D3DXVec2Transform(&temp, vIn, mIn);
	return D3DXVECTOR2(temp.x, temp.y);
}
//Transforms a 3D vector using D3DX functions.
inline D3DXVECTOR3 TransformVector(D3DXVECTOR3* vIn, D3DXMATRIX* mIn)
{
	D3DXVECTOR4 temp;
	D3DXVec3Transform(&temp, vIn, mIn);
	return D3DXVECTOR3(temp.x, temp.y, temp.z);
}

//Random number functions
inline float RandFloat()
{
	return ((rand())/(RAND_MAX+1.0));
}

inline float RandomClamped()
{
	return RandFloat() - RandFloat();
}
