#include "EntityGenerator.h"
#include "Defines.h"
#include "EntityManager.h"
#include "Agent.h"
#include "AgentTeam.h"
#include "Pickups.h"


EntityGenerator::EntityGenerator()
{
	m_NextValidID = 3;
}

EntityGenerator* EntityGenerator::Instance()
{
	static EntityGenerator instance;
	return &instance;
}

int EntityGenerator::CreateEntity(EntityType type)
{
	switch(type)
	{
	case EntityType::ent_Agent:
		m_NextValidID++;
		gEntities->AddEntity(new Agent(m_NextValidID - 1));
		return m_NextValidID - 1;
	case EntityType::ent_Team:
		m_NextValidID++;
		gEntities->AddEntity(new AgentTeam(m_NextValidID - 1));
		return m_NextValidID - 1;
	case EntityType::ent_HealthPickup:
		m_NextValidID++;
		gEntities->AddEntity(new HealthPickup(m_NextValidID - 1));
		return m_NextValidID - 1;
	case EntityType::ent_AmmoPickup:
		m_NextValidID++;
		gEntities->AddEntity(new AmmoPickup(m_NextValidID - 1));
		return m_NextValidID - 1;
	}
	return -1;
}

