#include "GameStateEnded.h"
#include "Defines.h"
#include "DirectX9App.h"
#include "DirectInput.h"
#include "D3DXMathFunctions.h"
#include "EntityGenerator.h"
#include "EntityManager.h"
#include "BaseEntity.h"
#include "AgentStates.h"
#include "Messages.h"
#include "AgentTeam.h"
#include "EntityGenerator.h"
#include "Pickups.h"
#include "DirectX9Game.h"


GameStateEnded::GameStateEnded():
	m_Obstacle1(D3DXVECTOR3(500,500,0)),
	m_Obstacle2(D3DXVECTOR3(200,650,0)),
	m_Obstacle3(D3DXVECTOR3(900,100,0)),
	m_Obstacle4(D3DXVECTOR3(650,250,0)),
	m_Obstacle5(D3DXVECTOR3(100,150,0))
{
	
}

GameStateEnded::~GameStateEnded()
{
	
}

GameStateEnded* GameStateEnded::Instance()
{
	static GameStateEnded instance;
	return &instance;
}

void GameStateEnded::Enter(DirectX9Game*)
{
	gEntities->Reset();
}

void GameStateEnded::Execute(DirectX9Game* owner, float dt)
{
	if(gInput->KeyDown(DIK_SPACE))
		owner->GetFSM()->ChangeState(GameStatePlaying::Instance());
}

void GameStateEnded::Render(DirectX9Game*)
{
	HR(gApplication->GetDefaultFont()->DrawText(gSprite, "Simulation Ended. Press Space to Restart or Escape to Exit", -1, &gApplication->GetWindowRect(), DT_LEFT | DT_NOCLIP, D3DCOLOR_ARGB(255,0,0,0)));
}
void GameStateEnded::Exit(DirectX9Game*)
{
	
}