#pragma once
#include "DirectX9App.h"
#include "Defines.h"

class Obstacle
{
	IDirect3DTexture9*  m_Tex;
	D3DXIMAGE_INFO		m_ImgInfo;
	D3DXVECTOR3			m_Position;
	float				m_ContactRadius;
public:
	Obstacle(){}
	~Obstacle()
	{
		SAFE_RELEASE(m_Tex);
	}

	Obstacle(D3DXVECTOR3 position)
	{
		HR(D3DXCreateTextureFromFileEx(gD3DDevice, "obstacle.png", 0,0,0,0,D3DFMT_UNKNOWN, D3DPOOL_MANAGED, D3DX_DEFAULT, D3DX_DEFAULT, D3DCOLOR_ARGB(255,0,0,255), &m_ImgInfo, 0, &m_Tex));
		m_Position = position;
		m_ContactRadius = 16.0f;
	}

	void Render()
	{
		D3DXMATRIX scaleMat, worldMat, transMat, rotMat;
		D3DXMatrixScaling(&scaleMat, 1.0f, 1.0f, 1.0f);
		D3DXMatrixTranslation(&transMat, m_Position.x, m_Position.y, 0.0f);
		D3DXMatrixMultiply(&worldMat, &scaleMat, &transMat);
		HR(gSprite->SetTransform(&worldMat));
		HR(gSprite->Draw(m_Tex, 0, &D3DXVECTOR3(m_ImgInfo.Width / 2.0f, m_ImgInfo.Height / 2.0f, 0.0f), 0, D3DCOLOR_ARGB(255,255,255,255)));
		HR(gSprite->Flush());
	}

	float GetRadius(){return m_ContactRadius;}
	D3DXVECTOR3 GetPosition(){return m_Position;}
	float GetContactRadius(){return m_ContactRadius;}
};