#include "Pickups.h"
#include "Messages.h"
#include "Defines.h"
#include "DirectX9App.h"
#include "D3DXMathFunctions.h"

AmmoPickup::AmmoPickup(int ID):BaseEntity(ID)
{
	m_AmountReloaded= 25.0f;
	m_Timeout = 10.0f;
	m_CooldownTime = 0.0f;
	m_IsActive = true;
	m_ContactRadius = 32.0f;
	D3DXCreateTextureFromFile(gD3DDevice, "ammo_pickup.png", &m_Texture);
}

void AmmoPickup::Update(float dt)
{
	if(m_CooldownTime > 0.0)
	{
		m_CooldownTime -= dt;
		m_IsActive = false;
	}
	else
		m_IsActive = true;
}

void AmmoPickup::Render()
{
	if(m_IsActive)
	{
		D3DXMATRIX transMat;
		D3DXMatrixTranslation(&transMat, m_Position.x, m_Position.y, 0.0f);
		HR(gSprite->SetTransform(&transMat));
		HR(gSprite->Draw(m_Texture, 0, &D3DXZEROVEC3, &D3DXZEROVEC3, D3DCOLOR_ARGB(255,255,255,255)));
		HR(gSprite->Flush());
	}
}

void AmmoPickup::ReceiveMessage(Telegram incoming)
{
	if(incoming.msg == Message::msg_Reset)
	{
		m_CooldownTime = m_Timeout;
	}
}

HealthPickup::HealthPickup(int ID):BaseEntity(ID)
{
	m_AmountHealed = 25.0f;
	m_Timeout = 10.0f;
	m_CooldownTime = 0.0f;
	m_IsActive = true;
	m_ContactRadius = 32.0f;
	D3DXCreateTextureFromFile(gD3DDevice, "health_pickup.png", &m_Texture);
}

void HealthPickup::Update(float dt)
{
	if(m_CooldownTime > 0.0)
	{
		m_CooldownTime -= dt;
		m_IsActive = false;
	}
	else
		m_IsActive = true;
}

void HealthPickup::Render()
{
	if(m_IsActive)
	{
		D3DXMATRIX transMat;
		D3DXMatrixTranslation(&transMat, m_Position.x, m_Position.y, 0.0f);
		HR(gSprite->SetTransform(&transMat));
		HR(gSprite->Draw(m_Texture, 0, &D3DXZEROVEC3, &D3DXZEROVEC3, D3DCOLOR_ARGB(255,255,255,255)));
		HR(gSprite->Flush());
	}
}

void HealthPickup::ReceiveMessage(Telegram incoming)
{
	if(incoming.msg == Message::msg_Reset)
	{
		m_CooldownTime = m_Timeout;
	}
}