#pragma once
#include <vector>
#include "d3dx9.h"
#include "DirectX9App.h"
#include "Defines.h"

class Bullet;
class Agent;

class Rifle
{
	int m_AmmoCount;
	int m_MaxAmmo;
	float m_Range;
	float m_Damage;
	Agent* m_Owner;
	std::vector<Bullet> m_Bullets;
	float m_RateOfFire;
	float m_FireCooldown;

public:
	Rifle():
		m_Owner(nullptr),
		m_Range(0.0f),
		m_Damage(0.0f),
		m_MaxAmmo(0)
	{
		m_AmmoCount = m_MaxAmmo;
		m_Bullets.clear();
		m_RateOfFire = 0.7f;
		m_FireCooldown = 0.0f;
	}

	Rifle(Agent* owner, float range, float damage, int maxAmmo):
		m_Owner(owner),
		m_Range(range),
		m_Damage(damage),
		m_MaxAmmo(maxAmmo)
	{
		m_AmmoCount = m_MaxAmmo;
		m_Bullets.clear();
		m_RateOfFire = 0.7f;
		m_FireCooldown = 0.0f;
	}

	void Fire();
	void Update(float dt);
	void Reload(int amount);
	int GetAmmoCount(){return m_AmmoCount;}
	int GetMaxAmmo(){return m_MaxAmmo;}
	void Render();
	
};

class Bullet
{
	D3DXVECTOR3 m_Position;
	D3DXVECTOR3 m_Direction;
	float m_Lifetime;
	float m_Speed;
	IDirect3DTexture9* m_Texture;
public:
	void Update(float dt);
	void Destroy(){m_Lifetime = 0.0f;}

	Bullet(float life, float speed, D3DXVECTOR3 direction, D3DXVECTOR3 position):
		m_Lifetime(life),
		m_Speed(speed),
		m_Direction(direction),
		m_Position(position)
	{
		D3DXCreateTextureFromFile(gD3DDevice, "bullet.png", &m_Texture);
	}

	float GetLifetime(){return m_Lifetime;}
	D3DXVECTOR3 GetPosition(){return m_Position;}
	void Render();
};
